﻿using System;
using Microsoft.Office.Interop.Excel;
using System.IO;
using System.Data.SQLite;
using System.Data;
using Microsoft.CSharp;
using System.Collections.Generic;
using System.Linq;
public class Script
{
    public static string Main(dynamic view)
 {

        //DevelopWorkspace.Base.Logger.WriteLine(DevelopWorkspace.Base.Dump.ToDump(M1()));
        //return "";
try{
        //DevelopWorkspace.Base.Logger.WriteLine("Process called");
        dynamic xlApp = DevelopWorkspace.Main.XlApp.Excel;
        xlApp.Visible = true;
	for(int iSheet=1;iSheet<xlApp.ActiveWorkbook.Worksheets.Count;iSheet++){
        	var targetSheet = xlApp.ActiveWorkbook.Worksheets(iSheet);
        //xlApp.ActiveWorkbook.ActiveSheet;
        object[,] value2_copy = targetSheet.Range(targetSheet.Cells(1, 1), targetSheet.Cells(targetSheet.UsedRange.Rows.Count, targetSheet.UsedRange.Columns.Count)).Value2;
        if(value2_copy.GetLength(0) < 8 || value2_copy.GetLength(1) < 8 ) continue;
	string tableName = ObjectValue(value2_copy[5, 5]);
	if(tableName == "" ) continue;
	string tableDesciption = ObjectValue(value2_copy[5, 2]);
	string columnName = "";
	string dataType = "";
	string dataLength = "";
	bool IsRequired = false;
	bool IsKey = false;
	List<string> keys = new List<string>();
	string template = @"DROP TABLE {0};
CREATE TABLE {1}
(
{2}
)
WITH (
  OIDS=FALSE
);
ALTER TABLE {3}
  OWNER TO postgres;
COMMENT ON TABLE {4}
  IS '{5}';";
	string columnsScript = "";
        for (int iRow = 8; iRow < value2_copy.GetLength(0); iRow++)
        {
        	columnName = ObjectValue(value2_copy[iRow, 3]);
        	dataType = ObjectValue(value2_copy[iRow, 5]);
        	dataLength = ObjectValue(value2_copy[iRow, 6]);
        	IsRequired = ObjectValue(value2_copy[iRow, 7]) == "○"?true:false;
        	IsKey = ObjectValue(value2_copy[iRow, 8]) == "○"?true:false;
        	if(columnName == "" ) break;
        	if(IsKey) keys.Add(columnName);
		columnsScript +=string.Format("{0} {1} {2} {3}{4}\n",columnName,dataType,dataLength != ""? "(" +dataLength + ")":"",IsRequired?"NOT NULL":"","," );


        	//for (int iCol = 1; iCol < value2_copy.GetLength(1); iCol++)
            //{
		//	DevelopWorkspace.Base.Logger.WriteLine(ObjectValue(value2_copy[iRow, iCol]));
		//}
	}
        columnsScript +=string.Format("CONSTRAINT {0}_pkey PRIMARY KEY ({1})",tableName,keys.Aggregate((i, j) => i + "," + j));
	string createScript =string.Format( template,	tableName,tableName,columnsScript,tableName,tableName,tableDesciption);
        DevelopWorkspace.Base.Logger.WriteLine(createScript.ToLower());


        }

        //dynamic xlApp = new Microsoft.Office.Interop.Excel.Application();
        //xlApp.Visible=true;
        //xlApp.Workbooks.Open(@"C:\workshop\証跡11.xlsx");
        //xlApp.Workbooks.Add();
        /*
            xlApp.ActiveWorkbook.Worksheets("Sheet1").Range("A1").Value = "A1 ";
            xlApp.ActiveWorkbook.Worksheets("Sheet1").Range("A2").Value = "A2 ";
            xlApp.ActiveWorkbook.Worksheets("Sheet1").Range("A3").Value = "A3 ";
            xlApp.ActiveWorkbook.Worksheets("Sheet1").Range("A4").Value = "A4 ";
            xlApp.ActiveWorkbook.Worksheets("Sheet1").Range("A5").Value = "A5 ";
            xlApp.ActiveWorkbook.Worksheets("Sheet1").Range("B1").Value = "B1 ";
            xlApp.ActiveWorkbook.Worksheets("Sheet1").Range("B2").Value = "B2 ";
            xlApp.ActiveWorkbook.Worksheets("Sheet1").Range("B3").Value = "B3 ";
            xlApp.ActiveWorkbook.Worksheets("Sheet1").Range("B4").Value = "B4 ";
            xlApp.ActiveWorkbook.Worksheets("Sheet1").Range("B5").Value = "B5 ";
            */
        //DevelopWorkspace.Base.Logger.WriteLine(DevelopWorkspace.Base.Dump.ToDump(xlApp.ActiveWorkbook.Worksheets("Sheet1").Range("A1:A5").Value));        
        //Demo1
        //Range selectedRange = xlApp.ActiveWorkbook.Worksheets("Sheet1").Range("A1:C5");
        //foreach( Range range in  selectedRange){
        //if (range.Value == null) continue;
        //	DevelopWorkspace.Base.Logger.WriteLine(range.Value.ToString());
        //}
        //多次元配列
        //object[,] selectedValue2 = xlApp.ActiveWorkbook.Worksheets("Sheet1").Range("A1:B5").Value2;
        //for(int row=1;row<=selectedValue2.GetLength(0);row++){
        //	for(int col=1;col<=selectedValue2.GetLength(1);col++){
        //	selectedValue2[row,col] = "overwritten" +row.ToString() +col.ToString();
        //	}
        //}			

        //xlApp.ActiveWorkbook.Worksheets("Sheet1").Range("A1:B5").Value2 =selectedValue2;

        //xlApp.ActiveWorkbook.Worksheets("Sheet1").Range("A5:B8").Value2 =M1();

        //xlApp.Quit();
        }
        catch(Exception ex){
        	DevelopWorkspace.Base.Logger.WriteLine(DevelopWorkspace.Base.Dump.ToDump(ex));
        }
        return "";
 }

   static string ObjectValue(object _object){
	if( _object == null ) return "";
	return _object.ToString();

    }

  static string[,] M1() 
    {
        string cs = "URI=file:test.db";
        
        List<List<string>> linked = new List<List<string>>();
        
        using(SQLiteConnection con = new SQLiteConnection("Data Source=test.db;Pooling=true;FailIfMissing=false")) 
        {
            con.Open();

            string stm = "SELECT * FROM highscores LIMIT 3";   
string [,] ret;
            using (SQLiteCommand cmd = new SQLiteCommand(stm, con))
            {

                using (SQLiteDataReader rdr = cmd.ExecuteReader())
                {
                
                    System.Data.DataTable schemaTable = rdr.GetSchemaTable();
                    List<string> schemaLinkedList = new List<string>();
                    foreach (System.Data.DataRow row in schemaTable.Rows)
                    {
                    	   schemaLinkedList.Add(row["ColumnName"].ToString() );
                    	    DevelopWorkspace.Base.Logger.WriteLine("L85");
                        //DevelopWorkspace.Base.Logger.WriteLine("\tDataTypeName: " + row["DataTypeName"] +"\tIsKey: " + row["IsKey"] +"\tIsUnique: " + row["IsUnique"] +"\tIsKey: " + row["IsKey"] +"\tColumnName: " + row["ColumnName"] +"\tColumnOrdinal: " + row["ColumnOrdinal"] +"\tColumnSize: " + row["ColumnSize"] +"\tDefaultValue: " + row["DefaultValue"]);                
                    }
                    linked.Add(schemaLinkedList);
			List<string> dataLinkedList = new List<string>();
			while (rdr.Read()){
				foreach(string columnName in schemaLinkedList){
			           dataLinkedList.Add(rdr[columnName].ToString() );
			       }
                           linked.Add(dataLinkedList);
			
			}
			ret= new string[linked.Count,schemaLinkedList.Count];
			for(int row=0;row<linked.Count;row++){
				for(int col=0;col<schemaLinkedList.Count;col++){
				ret[row,col] = linked[row][col];
				}
			}			
			
			
                }
            }

            con.Close();
            return ret;
         }
    }


}