﻿using System;
using Microsoft.Office.Interop.Excel;
using System.IO;
using System.Data.SQLite;
using System.Data;
using Microsoft.CSharp;
using System.Collections.Generic;
public class Script
{
    public static string Main(dynamic view)
    {
try{
        //DevelopWorkspace.Base.Logger.WriteLine(DevelopWorkspace.Base.Dump.ToDump(M1()));
        //return "";

        //DevelopWorkspace.Base.Logger.WriteLine("Process called");
                DevelopWorkspace.Base.Logger.WriteLine("17");
        dynamic xlApp=null;
        try{
        xlApp=(Microsoft.Office.Interop.Excel.Application)System.Runtime.InteropServices.Marshal.GetActiveObject("Excel.Application");
        }
        catch(Exception ex){
        
        }
                DevelopWorkspace.Base.Logger.WriteLine("19");
        if ( xlApp == null ) {
                DevelopWorkspace.Base.Logger.WriteLine("20");
        	   xlApp = new Microsoft.Office.Interop.Excel.Application();
        	   xlApp.Workbooks.Add();

        }
        DevelopWorkspace.Base.Logger.WriteLine("23");
        if( xlApp.Workbooks.Count == 0 ){
        DevelopWorkspace.Base.Logger.WriteLine("24");
                xlApp.Workbooks.Add();
         }
        xlApp.Visible = true;
        xlApp.ScreenUpdating = false;
        /*
            xlApp.ActiveWorkbook.Worksheets("Sheet1").Range("A1").Value = "A1 ";
            xlApp.ActiveWorkbook.Worksheets("Sheet1").Range("A2").Value = "A2 ";
            xlApp.ActiveWorkbook.Worksheets("Sheet1").Range("A3").Value = "A3 ";
            xlApp.ActiveWorkbook.Worksheets("Sheet1").Range("A4").Value = "A4 ";
            xlApp.ActiveWorkbook.Worksheets("Sheet1").Range("A5").Value = "A5 ";
            xlApp.ActiveWorkbook.Worksheets("Sheet1").Range("B1").Value = "B1 ";
            xlApp.ActiveWorkbook.Worksheets("Sheet1").Range("B2").Value = "B2 ";
            xlApp.ActiveWorkbook.Worksheets("Sheet1").Range("B3").Value = "B3 ";
            xlApp.ActiveWorkbook.Worksheets("Sheet1").Range("B4").Value = "B4 ";
            xlApp.ActiveWorkbook.Worksheets("Sheet1").Range("B5").Value = "B5 ";
            */
             if (xlApp == null)
            DevelopWorkspace.Base.Logger.WriteLine("12");
           
        var targetSheet = xlApp.ActiveWorkbook.ActiveSheet;
        
        DevelopWorkspace.Base.Logger.WriteLine(DevelopWorkspace.Base.Dump.ToDump(targetSheet));
        //targetSheet.Range(targetSheet.Cells(1,1),targetSheet.Cells(5,2)).NumberFormat = "@";
        //targetSheet.Range(targetSheet.Cells(1,1),targetSheet.Cells(5,2)).Interior.Pattern = Microsoft.Office.Interop.Excel.Constants.xlSolid;
        //targetSheet.Range(targetSheet.Cells(1,1),targetSheet.Cells(5,2)).Interior.ThemeColor = Microsoft.Office.Interop.Excel.XlThemeColor.xlThemeColorAccent5;

        //DevelopWorkspace.Base.Logger.WriteLine(DevelopWorkspace.Base.Dump.ToDump(xlApp.ActiveWorkbook.Worksheets("Sheet1").Range("A1:A5").Value));        
        //Demo1
        //Range selectedRange = xlApp.ActiveWorkbook.Worksheets("Sheet1").Range("A1:C5");
        //foreach( Range range in  selectedRange){
        //if (range.Value == null) continue;
        //	DevelopWorkspace.Base.Logger.WriteLine(range.Value.ToString());
        //}
        //多次元配列
        //object[,] selectedValue2 = xlApp.ActiveWorkbook.Worksheets("Sheet1").Range("A1:B5").Value2;

        /*
        targetSheet = xlApp.ActiveWorkbook.Worksheets("Sheet1");
        object[,] selectedValue2 = targetSheet.Range(targetSheet.Cells(1,1),targetSheet.Cells(5,2)).Value2;
        for(int row=1;row<=selectedValue2.GetLength(0);row++){
            for(int col=1;col<=selectedValue2.GetLength(1);col++){
            selectedValue2[row,col] = "overwritten" +row.ToString() +col.ToString();
            }
        }			
        targetSheet.Range(targetSheet.Cells(1,1),targetSheet.Cells(5,2)).Value2 =selectedValue2;
        */

        int sartRow = 1;
        int startCol = 2;
        Range selected;
        string[] selectTableNameList = new string[] { "Customers", "Orders", "Employees" };

        
        foreach (string tableName in selectTableNameList)
        {
        
            //Table属性定义行区域颜色定制
            selected = targetSheet.Range(targetSheet.Cells(sartRow, startCol),
                                targetSheet.Cells(sartRow, startCol + 1));
            selected.Interior.Pattern = Microsoft.Office.Interop.Excel.Constants.xlSolid;
            selected.Interior.ThemeColor = Microsoft.Office.Interop.Excel.XlThemeColor.xlThemeColorAccent4;
            selected.Value2 = new string[]{tableName,tableName};
            Script.DrawBorder(selected);
		            
           
            sartRow++;

	      string[,] value2_copy = GetTableDataWithSchema(tableName);
            //Table属性定义行区域颜色定制
            selected = targetSheet.Range(targetSheet.Cells(sartRow, startCol),
                                targetSheet.Cells(sartRow + Script.schemaList.GetLength(0) - 1, value2_copy.GetLength(1) + startCol - 1));
            selected.Interior.Pattern = Microsoft.Office.Interop.Excel.Constants.xlSolid;
            selected.Interior.ThemeColor = Microsoft.Office.Interop.Excel.XlThemeColor.xlThemeColorAccent5;
            //Data拷贝到指定区域
            selected = targetSheet.Range(targetSheet.Cells(sartRow, startCol),
                                targetSheet.Cells(value2_copy.GetLength(0) + sartRow - 1, value2_copy.GetLength(1) + startCol - 1));
            selected.NumberFormat = "@";
            selected.Value2 = value2_copy;
            Script.DrawBorder(selected);
            //xlApp.ActiveWorkbook.Worksheets("Sheet1").Range("A5:B108").Value2 =M1();
            sartRow = value2_copy.GetLength(0) + sartRow + 2;
        }
	targetSheet.Columns("B:AZ").EntireColumn.AutoFit();

xlApp.ScreenUpdating = true;
        xlApp.Quit();
}
catch(Exception ex){
DevelopWorkspace.Base.Logger.WriteLine(ex.Message);
}
        return "";
    }

    static string[] schemaList = new string[] { "ColumnName", "IsKey", "DataTypeName", "ColumnSize" };
    static void DrawBorder(Range selected)
    {
        XlBordersIndex[] borderIndexes = new XlBordersIndex[]{
                                                                                                        XlBordersIndex.xlEdgeLeft,
                                                                                                        XlBordersIndex.xlEdgeTop,
                                                                                                        XlBordersIndex.xlEdgeBottom,
                                                                                                        XlBordersIndex.xlEdgeRight,
                                                                                                        XlBordersIndex.xlInsideVertical,
                                                                                                        XlBordersIndex.xlInsideHorizontal};

            foreach(XlBordersIndex idx in borderIndexes){
		        selected.Borders[idx].LineStyle = XlLineStyle.xlContinuous;
		        selected.Borders[idx].ColorIndex = 0;
		        selected.Borders[idx].TintAndShade = 0;
		        selected.Borders[idx].Weight = XlBorderWeight.xlThin;
		            
            }

    }
    static string[,] GetTableDataWithSchema(string tableName)
    {
        string cs = "URI=file:test.db";

        List<List<string>> linked = new List<List<string>>();

        using (SQLiteConnection con = new SQLiteConnection("Data Source=northwindEF.db;Pooling=true;FailIfMissing=false"))
        {
            con.Open();

            //string stm = "SELECT * FROM highscores LIMIT 100";   
            string stm = string.Format("SELECT * FROM {0}", tableName);
            string[,] ret;
            using (SQLiteCommand cmd = new SQLiteCommand(stm, con))
            {

                using (SQLiteDataReader rdr = cmd.ExecuteReader())
                {

                    System.Data.DataTable schemaTable = rdr.GetSchemaTable();
                    List<string> schemaLinkedList = null;
                    foreach (string keyword in Script.schemaList)
                    {
                        schemaLinkedList = new List<string>();
                        //字段名取得
                        foreach (System.Data.DataRow row in schemaTable.Rows)
                        {
                            if (keyword == "IsKey")
                            {
                                if (row[keyword].ToString() == "True")
                                {
                                    schemaLinkedList.Add("*");
                                }
                                else
                                {
                                    schemaLinkedList.Add("");
                                };
                            }
                            else
                            {
                                schemaLinkedList.Add(row[keyword].ToString());
                            }

                            DevelopWorkspace.Base.Logger.WriteLine(row[keyword].ToString());
                            //DevelopWorkspace.Base.Logger.WriteLine("\tDataTypeName: " + row["DataTypeName"] +"\tIsKey: " + row["IsKey"] +"\tIsUnique: " + row["IsUnique"] +"\tIsKey: " + row["IsKey"] +"\tColumnName: " + row["ColumnName"] +"\tColumnOrdinal: " + row["ColumnOrdinal"] +"\tColumnSize: " + row["ColumnSize"] +"\tDefaultValue: " + row["DefaultValue"]);                
                        }
                        linked.Add(schemaLinkedList);
                    }
                    List<string> dataLinkedList = new List<string>();
                    schemaLinkedList = linked[0];
                    while (rdr.Read())
                    {
                        foreach (string columnName in schemaLinkedList)
                        {
                            dataLinkedList.Add(rdr[columnName].ToString());
                        }
                        linked.Add(dataLinkedList);

                    }
                    //DevelopWorkspace.Base.Logger.WriteLine("151");
                    //List内容转换成二维数组
                    ret = new string[linked.Count, schemaLinkedList.Count];
                    for (int row = 0; row < linked.Count; row++)
                    {
                        for (int col = 0; col < schemaLinkedList.Count; col++)
                        {
                            ret[row, col] = linked[row][col];
                        }
                    }


                }
            }

            con.Close();
            return ret;
        }
    }


}