﻿using System;
using Microsoft.Office.Interop.Excel;
using System.IO;
using System.Data.SQLite;
using System.Data;
public class Script
{
    public static string Main(dynamic view)
 {
 
 
M1();
 return "";
     	DevelopWorkspace.Base.Logger.WriteLine("Process called");
	SQLiteConnection m_dbConnection;
	SQLiteConnection.CreateFile("test.db");
	//m_dbConnection = new SQLiteConnection("Data Source=C:\\workshop\\excel-addon\\sqlite\\MyDatabase.sqlite");
	m_dbConnection = new SQLiteConnection("Data Source=test.db;Pooling=true;FailIfMissing=false");

	//
	m_dbConnection.Open();

	string sql = @"create table highscores (
	    name varchar(20), -- A field comment 
	    score int  -- A field comment
	)";
	SQLiteCommand command = new SQLiteCommand(sql, m_dbConnection);
	command.ExecuteNonQuery();

	sql = "insert into highscores (name, score) values ('Me', 3000)";
	command = new SQLiteCommand(sql, m_dbConnection);
	command.ExecuteNonQuery();

	sql = "insert into highscores (name, score) values ('Myself', 6000)";
	command = new SQLiteCommand(sql, m_dbConnection);
	command.ExecuteNonQuery();

	sql = "insert into highscores (name, score) values ('And I', 9001)";
	command = new SQLiteCommand(sql, m_dbConnection);
	command.ExecuteNonQuery();

	sql = "select * from highscores order by score desc";
	command = new SQLiteCommand(sql, m_dbConnection);
	SQLiteDataReader reader = command.ExecuteReader();
	while (reader.Read()){
		DevelopWorkspace.Base.Logger.WriteLine("Name: " + reader["name"] + "\tScore: " + reader["score"]);
	}

System.Data.DataTable tables = m_dbConnection.GetSchema("Tables");
System.Data.DataTable columns = m_dbConnection.GetSchema("Columns");
DevelopWorkspace.Base.Logger.WriteLine(DevelopWorkspace.Base.Dump.ToDump(tables));
//M1();

	return "";
 }
 
 
     static void M1() 
    {
        string cs = "URI=file:test.db";

        using(SQLiteConnection con = new SQLiteConnection("Data Source=test.db;Pooling=true;FailIfMissing=false")) 
        {
            con.Open();

            string stm = "SELECT * FROM highscores LIMIT 3";   

            using (SQLiteCommand cmd = new SQLiteCommand(stm, con))
            {

                using (SQLiteDataReader rdr = cmd.ExecuteReader())
                {
                
			//while (reader.Read()){
			//DevelopWorkspace.Base.Logger.WriteLine("\tScore: " + reader["DataTypeName"] +"\tScore: " + reader["IsKey"] +"\tScore: " + reader["IsUnique"] +"\tScore: " + reader["IsKey"] +"\tScore: " + reader["ColumnName"] +"\tScore: " + reader["ColumnOrdinal"] +"\tScore: " + reader["ColumnSize"] +"\tScore: " + reader["DefaultValue"]);                
			//}
			
                    System.Data.DataTable schemaTable = rdr.GetSchemaTable();

                    foreach (System.Data.DataRow row in schemaTable.Rows)
                    {
                        //foreach (DataColumn col in schemaTable.Columns)
                        //    DevelopWorkspace.Base.Logger.WriteLine(col.ColumnName + " = " + row[col]);
                        DevelopWorkspace.Base.Logger.WriteLine("\tDataTypeName: " + row["DataTypeName"] +"\tIsKey: " + row["IsKey"] +"\tIsUnique: " + row["IsUnique"] +"\tIsKey: " + row["IsKey"] +"\tColumnName: " + row["ColumnName"] +"\tColumnOrdinal: " + row["ColumnOrdinal"] +"\tColumnSize: " + row["ColumnSize"] +"\tDefaultValue: " + row["DefaultValue"]);                
                    }
                    
                }
            }

            con.Close();
         }
    }
 
 
 
     static void M2() 
    {
        string cs = "URI=file:test.db";

        using(SQLiteConnection con = new SQLiteConnection("Data Source=northwindEF.db;Pooling=true;FailIfMissing=false")) 
        {
            con.Open();

            string stm = "SELECT name, sql FROM sqlite_master WHERE type='table'  ORDER BY name";   

            using (SQLiteCommand cmd = new SQLiteCommand(stm, con))
            {

                using (SQLiteDataReader reader = cmd.ExecuteReader())
                {
while (reader.Read()){
//这个可以把创建SQL是的脚本，带有注释的。可以通过解析这个文字串取得注释
		DevelopWorkspace.Base.Logger.WriteLine("Name: " + reader["name"] + "\tScore: " + reader["sql"]);
	}
}
            }

            con.Close();
         }
    }
 
 
}
